# euler method for computation for the vertices
import numpy as np
import matplotlib.pyplot as plt
import pandas as pd

# ## Raeuber Beute Modell

# def raeuber_beute(HF):
#     a = 1
#     b = 3
#     c = 1
#     d = 0.7
#     return np.array([a*HF[0]-c*HF[0]*HF[1], -b*HF[1]+d*HF[0]*HF[1]])

# time_step = 0.0001
# nr_steps = 12800*3
# nr_steps *= 3
# time = np.zeros(nr_steps+1)
# for i in range(nr_steps+1):
#     time[i] = i*time_step
# solution = np.zeros((nr_steps+1, 2))
# solution[0, :] = [5,2]
# for i in range(0,nr_steps):
#     solution[i+1,:] = solution[i,:]+raeuber_beute(solution[i,:])*time_step

# stepper = 100

# raeuber_data = {'a':time[::stepper], 'b':solution[::stepper,1]}

# df = pd.DataFrame(raeuber_data)
# df.to_csv('raeuber.csv')

# beute_data = {'a':time[::stepper], 'b':solution[::stepper,0]}

# df = pd.DataFrame(beute_data)
# df.to_csv('beute.csv')

# solution_data = {'a':solution[::stepper,0], 'b':solution[::stepper,1]}

# df = pd.DataFrame(solution_data)
# df.to_csv('phasendiagram.csv')

# print("Max time = "+str(max(time))+", Max Beute = "+str(max(solution[:,0]))+", Max Raeuber = "+str(max(solution[:,1])))

# # plotting

# plt.plot(time[::stepper], solution[::stepper, 0], c='r')
# plt.plot(time[::stepper], solution[::stepper, 1], c='b')
# plt.show()

# plt.plot(solution[::stepper, 0], solution[::stepper, 1])
# plt.show()

## S-I-R Modell

def SIR_modell(SIR):
    a = 0.002
    b = 0.4
    return np.array([- a * SIR[0]*SIR[1], a*SIR[0]*SIR[1]-b*SIR[1], b*SIR[1]])

time_step = 0.0001
nr_steps = 12800*3
nr_steps *= 3
time = np.zeros(nr_steps+1)
for i in range(nr_steps+1):
    time[i] = i*time_step
solution = np.zeros((nr_steps+1, 3))
solution[0, :] = [1000, 10, 0]
for i in range(0,nr_steps):
    solution[i+1,:] = solution[i,:]+SIR_modell(solution[i,:])*time_step

stepper = 100
scaler = 200

S = {'a':time[::stepper], 'b':solution[::stepper, 0]/scaler}

df = pd.DataFrame(S)
df.to_csv('S.csv')

I = {'a':time[::stepper], 'b':solution[::stepper, 1]/scaler}

df = pd.DataFrame(I)
df.to_csv('I.csv')

R = {'a':time[::stepper], 'b':solution[::stepper, 2]/scaler}

df = pd.DataFrame(R)
df.to_csv('R.csv')

print("Max time = "+str(max(time))+", Max S = "+str(max(solution[:,0]/scaler))+", Max I = "+str(max(solution[:,1]/scaler))+", Max R = "+str(max(solution[:,2]/scaler)))

# # plotting

plt.plot(time[::stepper], solution[::stepper, 0], c='r')
plt.plot(time[::stepper], solution[::stepper, 1], c='b')
plt.plot(time[::stepper], solution[::stepper, 2], c='g')
plt.show()
